import { pTokensAsset } from 'ptokens-entities';
import { pTokensNode, InnerTransactionStatus } from 'ptokens-node';
import PromiEvent from 'promievent';
import BigNumber from 'bignumber.js';
export declare type DestinationInfo = {
    asset: pTokensAsset;
    destinationAddress: string;
    userData?: Uint8Array;
};
export declare class pTokensSwap {
    private _node;
    private _sourceAsset;
    private _destinationAssets;
    private _amount;
    private controller;
    constructor(node: pTokensNode, sourceAsset: pTokensAsset, destinationAssets: Array<DestinationInfo>, amount: BigNumber);
    get sourceAsset(): pTokensAsset;
    get destinationAssets(): Array<pTokensAsset>;
    get amount(): string;
    get node(): pTokensNode;
    private monitorInputTransactions;
    private monitorOutputTransactions;
    abort(): void;
    execute(): PromiEvent<InnerTransactionStatus[]>;
}
